// Auto-generated. Do not edit!

// (in-package ros_monitoring_msgs.msg)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;

//-----------------------------------------------------------

class MetricDimension {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.name = null;
      this.value = null;
    }
    else {
      if (initObj.hasOwnProperty('name')) {
        this.name = initObj.name
      }
      else {
        this.name = '';
      }
      if (initObj.hasOwnProperty('value')) {
        this.value = initObj.value
      }
      else {
        this.value = '';
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type MetricDimension
    // Serialize message field [name]
    bufferOffset = _serializer.string(obj.name, buffer, bufferOffset);
    // Serialize message field [value]
    bufferOffset = _serializer.string(obj.value, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type MetricDimension
    let len;
    let data = new MetricDimension(null);
    // Deserialize message field [name]
    data.name = _deserializer.string(buffer, bufferOffset);
    // Deserialize message field [value]
    data.value = _deserializer.string(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    length += object.name.length;
    length += object.value.length;
    return length + 8;
  }

  static datatype() {
    // Returns string type for a message object
    return 'ros_monitoring_msgs/MetricDimension';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return 'bc6ccc4a57f61779c8eaae61e9f422e0';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    ###################################
    # Metric Dimensions provide an additional way to group, sort, and filter metrics.
    #
    # For example, you may have a large number of robots running in different factories. They are all publishing a metric
    # that indicates how long it takes them to perform a specific task. If we're just looking at all the metrics coming from
    # all the robots then we lose the ability to figure out things like if robots in one factory take longer to perform a
    # task than in another factory. Dimensions allow us to solve this by include a dimension name "factory" with the factory
    # name the robot is running in with each metric it publishes. Then we could look at the metrics for all robots or filter
    # down to just robots in a specific factory.
    #
    # Additionally, if we wanted to A/B test software versions we could add another dimension named "software_version" that
    # has a value set to the version of software the metric is produced from. Then we could group by the version of software
    # as well as which factory the robot is in.
    #
    ###################################
    
    # The name of the Metric Dimension
    string name
    
    # The value for the dimension
    string value
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new MetricDimension(null);
    if (msg.name !== undefined) {
      resolved.name = msg.name;
    }
    else {
      resolved.name = ''
    }

    if (msg.value !== undefined) {
      resolved.value = msg.value;
    }
    else {
      resolved.value = ''
    }

    return resolved;
    }
};

module.exports = MetricDimension;
